SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 19:17'!
test01CartShouldBeEmptyWhenCreated

	| aCart |
	
	aCart := Cart new.
	
	self assert: ( aCart isEmpty ).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 19:23'!
test02CartShouldNotBeEmptyWhenAddAnElement

    | aCart |
   
    aCart := Cart new.
    aCart addProduct: 'aProduct'.
   
    self deny: aCart isEmpty! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 20:41'!
test03TwoEqualProductsCanBeAddedToTheCart

	|aCart aProduct otherProduct|

	aCart := Cart new.
	aProduct  := 'isbn12234-14252-15252-152512'.
	otherProduct  := 'isbn12234-14252-15252-152512'.
	
	aCart addProduct: aProduct .
	aCart addProduct: otherProduct .

	self assert: ( aProduct = otherProduct  and: [aCart products size = 2]).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 20:41'!
test04WhenAskAProductQuantityOfADontAddedProductShouldReturnZero
  
	|aCart aProduct otherProduct|

	aCart := Cart new.
	aProduct  := 'isbn12234-14252-15252-152512'.
	otherProduct  := 'isbn12234-14252-15252-152513'.
	
	aCart addProduct: aProduct .

	self assert: ( (aCart quantityOf: otherProduct) = 0).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 20:22'!
test05WhenAskForAProductQuantityShouldReturnTheQuantityAdded
  
	|aCart aProduct otherProduct|

	aCart := Cart new.
	aProduct  := 'isbn12234-14252-15252-152512'.
	otherProduct  := 'isbn12234-14252-15252-152512'.
	
	aCart addProduct: aProduct .
	aCart addProduct: otherProduct .

	self assert: ( (aCart quantityOf: aProduct) = 2).
	self assert: ( (aCart quantityOf: otherProduct) = 2).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 20:41'!
test06WhenListACartShouldHaveAllAddedElements

	|aCart aProduct otherProduct productsAdded|
	
	aCart := Cart new.
	aProduct  := 'isbn12234-14252-15252-152512'.
	otherProduct  := 'isbn12234-14252-15252-152513'.
	
	aCart addProduct: aProduct .
	aCart addProduct: otherProduct .

	productsAdded := (Array with: aProduct with: otherProduct ) .

	(aCart products) do: [ :aProductList | self assert: (productsAdded includes: aProductList)].! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 21:03'!
test07AddingAProductSpecifingTheQuantityShouldAddTheRightAmountOfProducts

	|aCart aProduct|

	aCart := Cart new.
	aProduct  := 'isbn12234-14252-15252-152512'.
	
	aCart addProduct: aProduct quantity: 3.

	self assert: ( aCart products size = 3).! !

Object subclass: #Cart
	instanceVariableNames: 'products'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/8/2012 21:14'!
addProduct: aProduct
 
	self addProduct: aProduct quantity: 1.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/11/2012 23:28'!
addProduct: aProduct quantity: anAmount
 
	self products add: aProduct withOccurrences: anAmount. ! !

!Cart methodsFor: 'comparing' stamp: 'PaneroGomez 6/8/2012 19:30'!
initialize

	products := Bag new.! !

!Cart methodsFor: 'comparing' stamp: 'PaneroGomez 6/11/2012 23:41'!
isEmpty

	^ products isEmpty.! !

!Cart methodsFor: 'comparing' stamp: 'PaneroGomez 6/8/2012 19:26'!
products

	^ products.! !

!Cart methodsFor: 'accessing' stamp: 'PaneroGomez 6/8/2012 20:13'!
quantityOf: aProduct
   
    ^ self products occurrencesOf: aProduct.! !
